#include <sourcemod>
#include <sdktools>

#define PLUGIN_VERSION "1.0"

public Plugin:myinfo =
{
	name = "DoD RealisticVoice",
	author = "FeuerSturm",
	description = "Add realistic listen/speak features to the VoiceComm",
	version = PLUGIN_VERSION,
	url = "http://www.dodsourceplugins.net"
}

new Float:PlayerPos[MAXPLAYERS+1][3]
new Handle:Distance = INVALID_HANDLE
new Handle:DistUnit = INVALID_HANDLE
new Handle:Enabled = INVALID_HANDLE
new bool:MapLoaded = false
new Handle:VoiceTimer = INVALID_HANDLE

public OnPluginStart()
{
	Distance = CreateConVar("dod_realisticvoice_distance", "60", "<#> set distance up to that players can hear each other", FCVAR_PLUGIN)
	DistUnit = CreateConVar("dod_realisticvoice_distanceunit", "1", "<1/2> set voice distance unit - 1=feet - 2=meters", FCVAR_PLUGIN, true, 1.0, true, 2.0)
	Enabled = CreateConVar("dod_realisticvoice_enabled", "0", "<1/0> enable/disable plugin", FCVAR_PLUGIN)
	HookConVarChange(Enabled, OnVoiceChanged)
}

public OnMapStart()
{
	MapLoaded = false
	VoiceTimer = INVALID_HANDLE
}

public OnConfigsExecuted()
{
	MapLoaded = true
	if(GetConVarInt(Enabled) == 1)
	{
		VoiceTimer = CreateTimer(1.0, CheckVoice, INVALID_HANDLE, TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE)
	}
}

public OnVoiceChanged(Handle:cvar, const String:oldVal[], const String:newVal[])
{
	if(!StrEqual(oldVal, newVal) && MapLoaded)
	{
		new value = StringToInt(newVal)
		if(value == 0)
		{
			if(VoiceTimer != INVALID_HANDLE)
			{
				CloseHandle(VoiceTimer)
			}
			VoiceTimer = INVALID_HANDLE
			for (new b = 1; b <= MaxClients; b++)
			{
				if(IsClientInGame(b) && !IsFakeClient(b))
				{
					for (new c = 1; c <= MaxClients; c++)
					{
						if(IsClientInGame(c) && !IsFakeClient(c))
						{
							SetListenOverride(b,c,Listen_Default)
						}
					}
				}
			}
		}
		if(value == 1)
		{
			if(VoiceTimer != INVALID_HANDLE)
			{
				CloseHandle(VoiceTimer)
			}
			VoiceTimer = CreateTimer(1.0, CheckVoice, INVALID_HANDLE, TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE)
		}
	}
}

public Action:CheckVoice(Handle:timer)
{
	if(GetConVarInt(Enabled) == 0)
	{
		if(VoiceTimer != INVALID_HANDLE)
		{
			CloseHandle(VoiceTimer)
		}
		VoiceTimer = INVALID_HANDLE
		return Plugin_Stop
	}
	new Float:ListenDistance = (GetConVarFloat(Distance)) * (GetConVarInt(DistUnit) == 1 ? 12.0 : 39.0)
	for (new a = 1; a <= MaxClients; a++)
	{
		if(IsClientInGame(a))
		{
			GetClientAbsOrigin(a, PlayerPos[a])
		}
	}
	for (new b = 1; b <= MaxClients; b++)
	{
		if(IsClientInGame(b) && !IsFakeClient(b))
		{
			for (new c = 1; c <= MaxClients; c++)
			{
				if(IsClientInGame(c) && !IsFakeClient(c))
				{
					if(IsPlayerAlive(b) && IsPlayerAlive(c))
					{
						if (GetVectorDistance(PlayerPos[b], PlayerPos[c], false) <= ListenDistance)
						{
							SetListenOverride(b,c,Listen_Yes)
						}
						else
						{
							SetListenOverride(b,c,Listen_No)
						}
					}
					else if((!IsPlayerAlive(b) && IsPlayerAlive(c)) || (IsPlayerAlive(b) && !IsPlayerAlive(c)))
					{
						SetListenOverride(b,c,Listen_No)
					}
					else if(!IsPlayerAlive(b) && !IsPlayerAlive(c))
					{
						SetListenOverride(b,c,Listen_Yes)
					}
				}
			}
		}
	}
	return Plugin_Handled
}